-- $Name: Сантехник$
-- $Version: 0.1$
-- $Author: Сантехник$
instead_version "2.1.0"

-- Модули
require "debug"  -- Отладчик
require "para"   -- Красивые отступы
require "dash"   -- Замена "--" на тире
require "quotes" -- Замена "" на типографические

-- Обработчики по умолчанию
game.act = "Это не для меня..."
game.use = "Батюшки, я лучше раком встану"
game.inv = "Накой мне это?"
game.forcedsc = false -- выводить статическое описание всегда

-- Глобальные переменные
global {
  
}

-- Начало игры
function init()
  print("Game started")
  take(apple)
  set_music("music/main.ogg")
end

apple = obj {
  nam = [[яблоко]];
  --disp = [[]]; 
  --dsc = [[{}]];
  --act = [[]];
  --tak = [[]];
  inv = code [[p "Съел яблоко. Как же я их люблю... Еще от одного бы не отказался."; remove(self, me())]];
  --obj = {};
  --var {};
}

-- nam: обязательное имя комнаты или объекта
-- disp: замена имени, false для объектов - не отображаться в инвентаре
-- dsc: описание комнаты или объекта в нем
-- obj: список объектов в комнате или в объекте
-- tak: описание действия взятия объекта
-- inv: при двойном клике по объекту инвентаря

-- p ""   - вывод в буффер
-- pn ""  - вывод в буффер новой строки
-- pclr() - очистка буффера
-- pget() - считать буффер



main = room {
  nam = "Начало";
  disp = "Чей-то туалет";
  --forcedsc = true;
  dsc = [[Вот надо же было согласиться на вызов перед самым концом рабочего дня? На часах - 18:35, а я только приехал. Срут и срут круглые сутки, до утра потерпеть не могут? Хорошо, хоть перекусить захватил.^^
  Как же меня достала эта работа. Уволюсь.]];
  obj = {"unitaz"};
  pic = "images/unitaz.png"
}

fly = room {
  nam = "Полет";
  disp = "Внутри трубы";
  dsc = [[Со свистом вода устремляется в трубу... Батюшки, меня засасывает в унитаз!!! Чувствую, что падаю. Пространство вокруг меня начало съеживаться, словно около чертовой черной дыры. ^^
  Нужно срочно что-то делать... ]];
  obj = {obj {
    nam = "действие";
    dsc = "Знаю, яблоко, надо {заткнуть дыру яблоком}";
    act = function (s)
      if have("apple") then
        p "Яблоко, где же оно?"
      else
        remove("stulchak", me())
        walk("final_false")
      end
    end;
    used = function(s,w)
      if w == apple then
        remove("stulchak", me())
        remove("apple", me())
        walk("final_true")
      end
    end;
  }};
  pic = "images/fly.png"
}

final_true = room {
  nam = "Хороший финал";
  dsc = [[Яблоко плотно закупорило дыру, пространство вокруг успокоилось. Что это было? Ну его ... Пойду ка лучше домой и забуду все как страшный сон. А стульчак на шее? Возьму в качестве оплаты. Будет у меня как ожерелье-талисман висеть. Главное все закончилось благополучно.^^
  Как же я тогда ошибался, все только начинается...^^
  Конец первой части.]];
  pic = "images/final_true.png"
}

final_false = room {
  nam = "Плохой финал";
  dsc = [[Что? Балда, я же его съел... Черная дыра уже перед самым моим носом и ...^^ В этом мире сантехника уже небыло... Лишь вовремя слетевший с шеи бедолаги стульчак отростил ножки, забрался на унитаз и замер, ожидая новую жертву.^^
  Конец первой части.]];
  pic = "images/final_false.png"
}

objectname = obj {
  nam = "";
  --disp = ; 
  --dsc = ;
  --act = ;
  --tak = ;
  --inv = ;
  --obj = ;
  --var {};
}

vantuz = obj {
  nam = "вантуз"; 
  --act = ;
  --tak = ;
  inv = "Даже нюхать не хочу, хоть и говорят будто свое не пахнет";
  --obj = ;
  --var {};
}

unitaz = obj {
  nam = "унитаз";
  disp = "ржавый унитаз"; 
  dsc = [[Передо мной стандартный {унитаз марки "Роса"}.]];
  act = "Что-то не так с этим монументом санфаянса. Не нравится мне он.";
  --tak = "";
  --inv = "";
  obj = {"zasor", "stulchak"};
  used = function (s, w)
    if w == vantuz then
      p "Вот тебе вантузом по харе, плохой унитаз"
    end
  end;
}

stulchak = obj {
  nam = "стульчак";
  disp = "стульчак на шее"; 
  dsc = "Cверху на нем {стульчак}.";
  --act = "";
  tak = function (s)
    p "Демонтировал стульчак, а девать то его некуда, пропадет ведь. Пришлось повесить на шею."
  end;
  var {_krepezi = true};
  inv = function(s)
    if s._krepezi then
      pn "Постойте-ка. Крепежи стульчака кокетливо болтаются в креплениях, а я их ой как люблю. Однозначно снимаю"
      s._krepezi = false
      take(obj {
        nam = "крепежи";
        inv = function(s)
          p "Съел крепежи. С детства как семечки щелкаю. Обычно после этого какаю вантузами... Ээээх вот и он родимый."
          remove(s, me())
          take("vantuz")
        end;
      })
    else
      p "Зачем я снял стульчак? Хобби, коллекционирую. Почему на шею? Удобно же. А вообще хватит с собой разговаривать."
    end
  end;
  --obj = {};
}

zasor = obj {
  nam = "засор";
  --disp = "";
  dsc = function(s)
    if not s._seen then
      p "Мутная вода внутри прямо таки {не хочет утекать}."
    else
      p "Невероятный {засор}."
    end
  end;
  act = function(s)
    if not s._seen then
      p "Похоже засорилось ссаными тряпками, причем конкретно"
      s._seen = true
    elseif have("vantuz") then
      p "Просто возьми вантуз и прочисть. Опять приходится себя уговаривать. У меня это с раннего детства."
    else
      p "Очевидный засор, чем бы прочистить?"
    end
  end;
  --tak = "";
  --inv = "";
  --obj = {};
  var {life = 3};
  used = function (s, w)
    if w ~= vantuz then
      p "Этим прочистить не получится"
      return false
    elseif s.life > 0 then
      p "Так ... уже лучше ... надо бы еще немного"
      s.life = s.life -1
    else
      remove("vantuz", me())
      walk("fly")
    end
  end;
}

--[[ Прочая инфа
F2/F3 - Меню сохранения/загрузки
F8/F9 - Быстрое сохранение/загрузка
Alt+R - Перезапуск (если выбран режим debug)
code " " - Запись функции для сохранения
]]